#include <time.h>
#include "sma02.h"
/*
 *	DOS płB
 */
typedef unsigned short ushort;
/*
 *	LPT  Base I/O AhX擾
 *	DOS  DOS ł܂B
 *	lptNo  1  LPT1 łB
 */ 
int LptGetPortAddr(int lptNo)
{
	ushort far *biosWork = (ushort far *)0x00400008L;
	if (lptNo < 1 || lptNo > 4) return 0;
	lptNo --;
	biosWork += lptNo;
	return *biosWork;
}

/*
 *	(STATUS & mask) == data ɂȂ܂ő҂B
 *	ő timeout(P msec) ̊ԑ҂B
 *
 *	߂l -1 Ȃ^CAEgB
 *	ȊO͍Ōɓǂ status łB
 */
int LptWaitStatus(int base, int mask, int data, int timeout)
{
	register int c;
	register clock_t till;
	
	c = IN(LPTSTAT(base));
	if ((c & mask) == data) return c & 0xff;
	
	till = clock() + timeout;
	/* CLOCKS_PER_SEC  1000 ̂͂B msec BłB */
	do {
		c = IN(LPTSTAT(base));
		if ((c & mask) == data) return c & 0xff;
	} while (clock() < till);

	return -1;
}

/*
 *	msec ҂B
 */
long WaitMSec(long msec)
{
	clock_t start = clock();
	clock_t till = start + msec;
	
	while (clock() < till);
	return clock() - start;
}

/*
 *	bidirectional T|[gĂ邩H
 *	1: Ă
 */
int LptIsBidirectionalSupported(int base)
{
	UCHAR c;
	int ok = 0;
	
	c = IN(LPTCTRL(base));
	OUT(LPTCTRL(base), c | CTL_DIR);	/* tri-state Ă炵 */
	OUT(LPTDATA(base), 0x55);
	if (IN(LPTDATA(base)) != 0x55) ok ++;
	OUT(LPTDATA(base), 0xaa);
	if (IN(LPTDATA(base)) != 0xaa) ok ++;
	/* CONTROL ɖ߂ */
	OUT(LPTCTRL(base), c);
	
	return (ok != 0);
}

